'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _rollupPluginBabelHelpers = require('../_virtual/_rollupPluginBabelHelpers.js');
var rxjs = require('rxjs');
var operators = require('rxjs/operators');
var observable = require('./internal/observable.js');

var Router = /*#__PURE__*/function () {
  function Router() {
    _rollupPluginBabelHelpers.classCallCheck(this, Router);

    _rollupPluginBabelHelpers.defineProperty(this, "event$", observable.getHistoryEventObservable().pipe(operators.share()));
  }

  _rollupPluginBabelHelpers.createClass(Router, [{
    key: "url",
    get: function get() {
      return rxjs.concat(rxjs.of(window.location.href), this.event$).pipe(operators.distinctUntilChanged());
    }
  }, {
    key: "urlChange",
    get: function get() {
      return this.event$.pipe(operators.distinctUntilChanged());
    }
  }]);

  return Router;
}();

exports.Router = Router;
//# sourceMappingURL=router.js.map
